% Script to process XML help files into HTML. This script can be invoked
% from the Matlab Start button (via the function qftm_helpup).
%
% Copyright  2008 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

L = {'abs'  'acos' 'acosh' 'adjoint' 'angle'...
     'arrayfun' ...
     'asin' 'asinh' 'atan' 'atanh'    'axis'...
     'blkdiag' 'bsxfun'...
     'cast' 'cat' 'cd' 'cdpolar' 'ceil' 'change_basis' 'char' 'complex' ...
     'conj' 'conv' 'conv2' 'convert' ...
     'cos' 'cosh' 'cross' 'ctranspose' 'cumprod' 'cumsum' ...
     'dc' 'det' 'diag' 'diff' 'disp' 'display' 'displayall' ...
     'eig' 'end' 'eq' 'exp' 'expm' 'eyeq' ...
     'fft' 'fft2' 'fftshift' 'fix' 'floor' 'fprintf' 'funm' ...
     'horzcat' ...
     'ifft' 'ifft2' 'ifftshift' 'iqdft' 'iqdft2' 'iqfft' 'iqfft2' ...
     'imag' 'image' 'imreadq' 'imwrite' ...
     'inv' 'ipermute' 'isempty' 'isfinite' 'ishermitian' 'isinf' ...
     'isnan' 'ispure' 'isreal' 'isunitary' ...
     'ldivide' 'length' 'log' 'logm' 'lu' ...
     'mean' 'minus' 'mpower' 'mrdivide' 'mtimes' ...
     'ndims' 'ne' 'norm' 'normq' 'numel' ...
     'onesq' 'orthogonal' 'orthonormal_basis' ...
     'permute' 'plus' 'power' 'prod' ...
     'q1' 'quaternion' 'qdft' 'qdft2' 'qfft' 'qfft2' 'qr' ...
     'qtfm_root' 'qtfm_test' ...
     'randf' 'randq' 'randv' 'randvmf' 'read' 'repmat' 'reshape' ...
     'rdivide' 'real' 'round' ...
     's' 'scalar_product' 'scatter3' 'show' 'sign' 'sin' 'sinh' 'size' ...
     'slerp' ...
     'sum' 'sqrt' 'sqrtm' 'squeeze' 'subsasgn' 'subsindex' 'subsref' ...
     'svd' 'svdj'...
     'tan' 'tanh' 'times' 'transpose' 'tril' 'triu' ...
     'uminus' 'unadjoint' 'uplus' 'unit' ...
     'v' 'vector_product' 'vertcat' ...
     'write' ...
     'xyz' ...
     'zerosq' 'zerosv'};

S = 'xmlfiles/qtfmfunction.xsl';

h = waitbar(0, 'Processing XML to HTML helpfiles ...');

N = length(L);

for i = 1:N
    F = L{i};
    waitbar(i/N, h)
    xslt(['xmlfiles/', F, '.xml'], S, [F, '.html']);
end
close(h)

% $Id: process.m,v 1.12 2010/02/13 20:46:23 sangwine Exp $
